<?php
namespace Reelworx\Datetimetest\Controller;

/***
 *
 * This file is part of the "DateTimeTest" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2017 Markus Klein <markus.klein@typo3.org>, Core Team
 *
 ***/

/**
 * HistoryController
 */
class HistoryController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{
    /**
     * historyRepository
     *
     * @var \Reelworx\Datetimetest\Domain\Repository\HistoryRepository
     * @inject
     */
    protected $historyRepository = null;

    /**
     * action list
     *
     * @return void
     */
    public function listAction()
    {
        $histories = $this->historyRepository->findAll();
        $this->view->assign('histories', $histories);
    }

    /**
     * action show
     *
     * @param \Reelworx\datetimetest\Domain\Model\History $history
     * @return void
     */
    public function showAction(\Reelworx\datetimetest\Domain\Model\History $history)
    {
        $this->view->assign('history', $history);
    }

    /**
     * action new
     *
     * @return void
     */
    public function newAction()
    {

    }

    /**
     * action create
     *
     * @param \Reelworx\datetimetest\Domain\Model\History $newHistory
     * @return void
     */
    public function createAction(\Reelworx\datetimetest\Domain\Model\History $newHistory)
    {
        $this->addFlashMessage('The object was created. Please be aware that this action is publicly accessible unless you implement an access check. See https://docs.typo3.org/typo3cms/extensions/extension_builder/User/Index.html', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::WARNING);
        $this->historyRepository->add($newHistory);
        $this->redirect('list');
    }

    /**
     * action edit
     *
     * @param \Reelworx\datetimetest\Domain\Model\History $history
     * @ignorevalidation $history
     * @return void
     */
    public function editAction(\Reelworx\datetimetest\Domain\Model\History $history)
    {
        $this->view->assign('history', $history);
    }

    /**
     * action update
     *
     * @param \Reelworx\datetimetest\Domain\Model\History $history
     * @return void
     */
    public function updateAction(\Reelworx\datetimetest\Domain\Model\History $history)
    {
        $this->addFlashMessage('The object was updated. Please be aware that this action is publicly accessible unless you implement an access check. See https://docs.typo3.org/typo3cms/extensions/extension_builder/User/Index.html', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::WARNING);
        $this->historyRepository->update($history);
        $this->redirect('list');
    }

    /**
     * action delete
     *
     * @param \Reelworx\datetimetest\Domain\Model\History $history
     * @return void
     */
    public function deleteAction(\Reelworx\datetimetest\Domain\Model\History $history)
    {
        $this->addFlashMessage('The object was deleted. Please be aware that this action is publicly accessible unless you implement an access check. See https://docs.typo3.org/typo3cms/extensions/extension_builder/User/Index.html', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::WARNING);
        $this->historyRepository->remove($history);
        $this->redirect('list');
    }
}
